%define vimver 5.7
%define vim vim57
Summary: A DOS emulator.
Name: dosemu
Version: 1.0.1
Release: 10
Exclusivearch: %{ix86}
Copyright: distributable
Group: Applications/Emulators
Source0: ftp://ftp.dosemu.org/dosemu/dosemu-1.0.1.tar.bz2
Source1: ftp://ftp.ibiblio.org/pub/micro/pc-stuff/freedos/files/distributions/beta5/base1.zip
Source2: ftp://ftp.ibiblio.org/pub/micro/pc-stuff/freedos/files/distributions/beta5/util1.zip
Source3: ftp://ftp.ibiblio.org/pub/micro/pc-stuff/freedos/files/distributions/beta5/edit1.zip
Source4: ftp://ftp.sourceforge.net/pub/sourceforge/freedos/ker2021.zip
Source5: ftp://ftp.home.vim.org/pub/vim/pc/%{vim}d16.zip
Source6: ftp://ftp.home.vim.org/pub/vim/pc/%{vim}rt.zip
Source7: autoexec.bat
Source8: config.sys
Epoch: 1
Patch0: dosemu-0.66.7-config.patch
Patch1: dosemu-0.66.7-glibc.patch
Patch2: dosemu-0.66.7-pushal.patch
Patch3: dosemu-0.98.1-security.patch
Patch4: dosemu-0.98.1-justroot.patch
Patch5: dosemu-imwheel.patch
Patch6: dosemu-imps2.patch
Patch7: dosemu-1.0.0-man.patch
Patch8: dosemu-1.0.1-glibc22.patch
Patch9: dosemu-1.0.1-broken.patch
Patch10: dosemu-1.0.0.5-noroot.patch
Patch11: dosemu-1.0.1-dosemu_bios.patch
Patch12: patch-1.0.1-missing-vmodem
Patch13: dosemu-1.0.1-cpp.patch
Patch14: dosemu-1.0.1-time.patch
Requires: kernel >= 2.0.28, mtools >= 3.6
Url: http://www.dosemu.org/
Buildroot: %{_tmppath}/%{name}-root
BuildPrereq: mtools >= 3.6

%package -n xdosemu
Requires: dosemu = %{PACKAGE_VERSION}
Summary: A DOS emulator for the X Window System.
Group: Applications/Emulators

%package freedos
Requires: dosemu = %{PACKAGE_VERSION}
Summary: A FreeDOS hdimage for dosemu, a DOS emulator, to use.
Group: Applications/Emulators

%description
Dosemu is a DOS emulator.  Once you've installed dosemu, start the DOS
emulator by typing in the dos command.

You need to install dosemu if you use DOS programs and you want to be
able to run them on your Red Hat Linux system.  You may also need to
install the dosemu-freedos package.

%description -n xdosemu
Xdosemu is a version of the dosemu DOS emulator that runs with the X
Window System.  Xdosemu provides VGA graphics and mouse support.

Install xdosemu if you need to run DOS programs on your system, and
you'd like to do so with the convenience of graphics support and mouse
capabilities.

%description freedos
Generally, the dosemu DOS emulator requires either that your system
have some version of DOS available or that your system's partitions
were formatted and installed with DOS. If your system does not meet
either of the previous requirements, you can instead use the dosemu-
freedos package, which contains an hdimage file which will be
installed in the /var/lib/dosemu directory. The hdimage file is
already bootable with FreeDOS.

You will need to edit your /etc/dosemu.conf file to add the
image to the list of disk 'drives' used by dosemu.

Install dosemu-freedos if you are installing the dosemu package, but
you don't have a version of DOS available on your system, and your
system's partitions were not formatted and installed with DOS.

%prep
%setup -q
%patch0 -p1 -b .lock
#%patch2 -p1 -b .pushal
%patch3 -p1 -b .security
%patch4 -p1 -b .justroot
%patch5 -R -p1 -b .imwheel
%patch6 -p1
%patch7 -p1 -b .man
%patch8 -p1 -b .glibc22
%patch9 -p1 -b .broken
%patch10 -p1 -b .nonroot
%patch11 -p1 -b .bios
%patch12 -p1 -b vmodem
%patch13 -p1 -b .time
%patch14 -p1 -b .cpp

rm -rf freedos
mkdir freedos
mkdir freedos/kernel
mkdir freedos/tmp
mkdir freedos/vim

unzip -o -L -d freedos/kernel/ -j %{SOURCE4}
cp -f contrib/dosC/dist/* freedos/kernel
for i in %{SOURCE1} %{SOURCE2} %{SOURCE3}; do
	unzip -L -d freedos/tmp $i
done
for i in freedos/tmp/*.zip ; do 
	unzip -L -o -d freedos $i
done
unzip -L -o -d freedos %{SOURCE6}
unzip -L -o -d freedos/vim-%{vimver} %{SOURCE5}
mv freedos/vim-%{vimver}/vim/%{vim}/vim.exe freedos/vim-%{vimver}/vim/%{vim}/vi.exe

%build
PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/X11R6/bin
./default-configure --without-x
make WAIT=no # echo | make
mv bin/dos bin/dos-nox
./default-configure
make WAIT=no # echo | make
mv bin/dos bin/dos-x
mv bin/dos-nox bin/dos

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc
make install INSTROOT=$RPM_BUILD_ROOT mandir=%{_mandir}/man1
rm $RPM_BUILD_ROOT/usr/bin/xdos
install -c -m 755 bin/dos-x $RPM_BUILD_ROOT/usr/bin/xdos
install -c -m 755 setup-hdimage $RPM_BUILD_ROOT/usr/bin
install -c -m 755 src/tools/periph/{dexeconfig,hdinfo,mkhdimage,mkfatimage16} $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/share/icons
install -c -m 644 etc/dosemu.xpm $RPM_BUILD_ROOT/usr/share/icons
install -c -m 644 etc/dosemu.users.secure $RPM_BUILD_ROOT/etc/dosemu.users
src/tools/periph/mkfatimage16 -p -k 16192 -l FreeDos \
	-b freedos/kernel/boot.bin \
	-f $RPM_BUILD_ROOT/var/lib/dosemu/hdimage.freedos \
	freedos/kernel/* 
FREEDOS=`/bin/mktemp /tmp/freedos.XXXXXX`
echo "drive n: file=\"$RPM_BUILD_ROOT/var/lib/dosemu/hdimage.freedos\" offset=8832" > $FREEDOS
MTOOLSRC=$FREEDOS
export MTOOLSRC
mcopy -o/ freedos/vim-%{vimver} freedos/bin freedos/doc freedos/help freedos/emacs n:
mmd n:/DOSEMU
mcopy -/ commands/* n:/DOSEMU
mcopy -o %{SOURCE7} %{SOURCE8} commands/exitemu* n:/
mdir -w n:
rm -f $FREEDOS
unset MTOOLSRC

install -c -m 644 etc/hdimage.dist $RPM_BUILD_ROOT/var/lib/dosemu/hdimage
# install dexe utils
install -c -m 755 dexe/{do_mtools,extract-dos,mkdexe,myxcopy} $RPM_BUILD_ROOT/usr/bin

cat <<EOF >$RPM_BUILD_ROOT/usr/bin/rundos
#!/bin/sh
BINDIR=/bin
export BINDIR 
# ignore errors if user does not have module installed
exec /usr/bin/dos $*
EOF
chmod 0755 $RPM_BUILD_ROOT/usr/bin/rundos

# Create .desktop file for KDE and GNOME menus...
mkdir -p $RPM_BUILD_ROOT/etc/X11/applnk/Emulators
cat >$RPM_BUILD_ROOT/etc/X11/applnk/Emulators/dosemu.desktop <<EOF
[Desktop Entry]
Name=DOSEmu
Type=Application
Description=DOS Emulator
Exec=xdos
Icon=dosemu.xpm
EOF

%post -n xdosemu
if [ -x /usr/X11R6/bin/mkfontdir ]; then
	(cd /usr/X11R6/lib/X11/fonts/misc; /usr/X11R6/bin/mkfontdir)
fi
killall -USR1 xfs > /dev/null 2>&1 || :

%postun -n xdosemu
if [ -x /usr/X11R6/bin/mkfontdir ]; then
	(cd /usr/X11R6/lib/X11/fonts/misc; /usr/X11R6/bin/mkfontdir)
fi
killall -USR1 xfs > /dev/null 2>&1 || :

%post freedos
[ -e /var/lib/dosemu/hdimage.first ] || \
    ln -s hdimage.freedos /var/lib/dosemu/hdimage.first

%postun freedos
if [ $1 = 0 ]; then
  if [ -e /var/lib/dosemu/hdimage.first ]; then
    rm -f /var/lib/dosemu/hdimage.first
  fi
fi
    
%files
%defattr(-,root,root)
%doc QuickStart doc/* README*
%dir /var/lib/dosemu
%config /etc/dosemu.conf
%config /etc/dosemu.users
%config /var/lib/dosemu/hdimage
%config /var/lib/dosemu/global.conf
%attr(755,root,root) /usr/bin/dos
/usr/bin/dosdebug
/usr/bin/dosexec
/usr/bin/dexeconfig
/usr/bin/hdinfo
/usr/bin/do_mtools
/usr/bin/extract-dos
/usr/bin/mkdexe
/usr/bin/myxcopy
/usr/bin/mkhdimage
/usr/bin/mkfatimage16
/usr/bin/rundos
/usr/bin/setup-hdimage
%{_mandir}/*/dos.1*
%{_mandir}/*/dosdebug.1*
%{_mandir}/*/mkfatimage16.1*

%files -n xdosemu
%defattr(-,root,root)
%config /etc/X11/applnk/Emulators/dosemu.desktop
/usr/bin/xdos
/usr/bin/xtermdos
%{_mandir}/*/xdos.1*
/usr/X11R6/lib/X11/fonts/misc/vga.pcf
/usr/share/icons/dosemu.xpm

%files freedos
%defattr(-,root,root)
%config /var/lib/dosemu/hdimage.freedos

%clean
rm -rf $RPM_BUILD_ROOT
rm -f dosemu.files

%changelog
* Wed Feb 28 2001 Than Ngo <than@redhat.com>
- fix to build against gcc 2.96

* Thu Feb 15 2001 Nalin Dahyabhai <nalin@redhat.com>
- include time.h where needed
- modify some pasting constructs to appease the preprocessor

* Wed Jan 10 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update DOS image:
  - FreeDOS beta 5
  - FreeDOS kernel 2021
  - VIM 5.7

* Tue Dec 19 2000 Than  Ngo <than@redhat.com>
- add vmodem patch
- bzip2 source

* Thu Aug 24 2000 Than Ngo <than@redhat.com>
- fix specfile (bug #16764)

* Mon Aug 14 2000 Than Ngo <than@redhat.com>
- fix dosemu bios location (Bug #15843)

* Thu Jul 27 2000 Than Ngo <than@redhat.de>
- don't need patch for workaround in cpp

* Wed Jul 26 2000 Than Ngo <than@redhat.de>
- workaround for bug in cpp
- fix unclean code

* Sun Jul 23 2000 Than Ngo <than@redhat.de>
- update to 1.0.1
- fix to built against 2.96
- don't hardcode mandir

* Mon Jul 17 2000 Tim Powers <timp@redhat.com>
- added defattr to freedos package

* Wed Jul 12 2000 Than Ngo <than@redhat.de>
- rebuilt

* Thu Jul 07 2000 Than Ngo <than@redhat.de>
- rebuilt to fix docdir
- don't use hard coding mandir PATH
- fix again to build with glibc-2.2
- fix to build as nonroot

* Sat May 27 2000 Ngo Than <than@redhat.de>
- put man pages to correct place
- fix dosemu to compiler with new glibc

* Fri Apr  7 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- BuildPrereq mtools
- Freedos kernel 2019

* Tue Apr 04 2000 Ngo Than <than@redhat.de>
- updated dosemu-1.0.0

* Mon Feb  7 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix description, summary, ...
- Add the vim and emacs directories to PATH
- rename vim.exe to vi.exe - people usually type vi and not vim.

* Sun Feb  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update Freedos to beta4
- remove the "unwanted extra features" (viruses!) we were shipping
  in the freedos root (Bug #8469)
- update the included vim for dos to 5.6 (horror - how am I supposed
  to even test this package without my favorite toy? ;) )
- deal with rpm compressing man pages
- minor fix to rundos script
- add a .desktop entry for xdosemu
- move the dosemu.xpm file from dosemu to xdosemu, where it belongs.
- allow build on i[456]86 arches
  
* Tue Feb  1 2000 Bill Nottingham <notting@redhat.com>
- document wheelmouse support

* Wed Jan 19 2000 Bill Nottingham <notting@redhat.com>
- add a patch for wheelmice from Hans de Goede (hans@highrise.nl)

* Sun Sep 19 1999 Matt Wilson <msw@redhat.com>
- version 0.99.13
- made a non x version as well an X version.

* Mon Jun 07 1999 Dale Lovelace <dale@redhat.com>
- remove ^H's from documentation
- freedos version beta 2
- add autoexec.bat and config.sys for path
- add freedos utils
- add vim

* Wed Mar 31 1999 Preston Brown <pbrown@redhat.com>
- add dexe stuff back into package

* Fri Mar 26 1999 Preston Brown <pbrown@redhat.com>
- remove hdimage.first link on deinstallation of freedos.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Wed Mar 17 1999 Matt Wilson <msw@redhat.com>
- fixed %post and %postun scripts
- version 0.99.10

* Tue Jan 12 1999 Matt Wilson <msw@redhat.com>
- version 0.99.6

* Sat Oct 10 1998 Cristian Gafton <gafton@redhat.com>
- strip binaries
- version 0.98.1
- freedos has its own subpackage

* Wed Jun 24 1998 Alan Cox <alan@redhat.com>
- Wrote additional fixes for dexe overflow problem in parser.y

* Tue Jun 23 1998 Alan Cox <alan@redhat.com>
- Applied the security fixes from Hans Lerman

* Fri May 08 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Fri Apr 10 1998 Cristian Gafton <gafton@redhat.com>
- added DOS-C kernel and FreeDos utilities

* Thu Jan 29 1998 Cristian Gafton <gafton@redhat.com>
- updated spec file to include all the available commands
- uses a buildroot
- ship mkfatimage16, which is the only binary that can create a real hdimage
  file

* Mon Nov 03 1997 Michael K. Johnson <johnsonm@redhat.com>
- Updated to 0.66.7
- Ported to glibc

* Wed Apr 16 1997 Erik Troan <ewt@redhat.com>
- Updated to 0.66.2.
- Removed /usr/bin/load-dosmods as we don't need emumod.o anymore

* Tue Mar 11 1997 Michael K. Johnson <johnsonm@redhat.com>
- Modify the default configuration file to use /var/lock in
  ascii format for lock files, as specified in the FSSTD/FHS.

* Thu Mar 06 1997 Michael K. Johnson <johnsonm@redhat.com>
- Assume vm86plus system call does not exist.
- N.B. This should be changed in a future version with a later kernel
  that supports that system call by default.
- Install the mkhdimage program.
